;**********************************************************************
;   .
;   - 4.
	list		p=16f876A	; list directive to define processor
	#include	<p16f876A.inc>	; processor specific variable definitions
	
	__CONFIG _CP_OFF & _WDT_ON & _BODEN_ON & _PWRTE_ON & _XT_OSC & _WRT_OFF & _LVP_OFF & _CPD_OFF

;---   --------------------------------------------------
	CBLOCK	0x20
				BITS
				BITS1
;  -------------------------
				TIME_MS20		;  20
				SEC
				MIN
				HOUR
;   --------------
				NUMCHAR			;    
				CHAR			;     
				PBIT			;   -    CHAR
;
				COUNTBIT		;      
				DATABYTE		;  
;
				VARONAIR
				TIME_SQ
				COUNTER1		;    CSQ
				COUNTER1A		;    CSQ
				COUNTER2		;   BEEP   CSQ
				COUNTER3		;    PTT
				COUNTER4		;    PTT
				COUNTER5		;    PTT
				COUNTER6		;     
;
				TON				; " "
				DTMFDATA
				DTMFSTRING:.20	; 20    
	ENDC
;
	CBLOCK	0x71
				w_temp				; variable used for context saving 
				status_temp			; variable used for context saving
				pclath_temp			; variable used for context saving			
	ENDC
;-------- BITS -----------------------------------------
#define	TAKT		BITS,0		;     TMR1 20 
#define	CSQBIT		BITS,1		; 1 -   CSQ
#define	BEEPBIT		BITS,2
#define ALARMBIT	BITS,3
#define TIMEisSET	BITS,4		;    
#define OPENCSQ		BITS,5		;     CSQ
#define	INFO		BITS,6		;  
;-------- BITS1 -----------------------------------------
#define	CSQON1		BITS1,0		;      CSQ  
#define CSQON2		BITS1,1		;       
#define CSQOF		BITS1,2
#define PINDTMF_1	BITS1,3		;  1  .   
#define NEWDTMF		BITS1,4		;   DTMF  
#define DTMF_OK		BITS1,5		;   -  !!!
#define BEACONBIT	BITS1,6		;   
#define BBEEP		BITS1,7		;   
;---------------------------------------------------------
LOBYTE		EQU		0xFF-0x42	; 50000	* 4 = 1000000 -  - 20: 0xC350-0x0C -   50000 
HIBYTE		EQU		0xFF-0xC3
HZ2000		EQU		.26		 	;   /16
HZ1500		EQU		.42
HZ1000		EQU		.62
HZ700		EQU		.89
HZ300		EQU		.208
TIMESQ1		EQU		.6			; 0.3  -    SQ   PTT	
TIMESQ2		EQU		.2			; 0.1  -    SQ   PTT	
TIMEOFFSQ1	EQU		.3			; 0.15  -    SQ 
TIME0FFBEEP	EQU		.16			; 0.8  -   BEEP
TIMEONAIR	EQU		.3			; 3  -   CSQ  
TIMEONAIR2	EQU		.10			; 10  -   CSQ   -   1
TIMEONAIR3	EQU		.30			; 30  -   CSQ   -   2
TIMEOUT		EQU		.62			; 62  -  CSQ
TIMEALARM	EQU		.3			; 3  - 
TIMEBEACON	EQU		.15			;  
;---------------------------------------------------------
#define	BANK0		BCF		STATUS,RP0
#define	BANK1		BSF		STATUS,RP0
;-------- PORT A -----------------------------------------
#define PINCSQ		PORTA,1
;-------- PORT B -----------------------------------------
#define	RXtoTX	PORTB,0
#define	RXtoTEL	PORTB,1
#define	TELtoRX	PORTB,2
#define	PINDTMF	PORTB,7
;-------- PORT C -----------------------------------------
#define	PINRXEN		PORTC,0
#define	PINTXEN		PORTC,1
#define PINPWM		PORTC,2
#define	PINCLOCK	PORTC,3
#define	PINDATA		PORTC,4
#define	MICtoTX		PORTC,5
#define	PTT			PORTC,6
#define	TELONLINE	PORTC,7
;----------------------------------------------------------
	ORG     0				; processor reset vector
  	nop						; nop required for icd
  	goto    START           ; go to beginning of program
;---------------------------------------------------------
		ORG     0x004             ; interrupt vector location
		movwf   w_temp            ; save off current W register contents
		movf	STATUS,w          ; move status register into W register
		movwf	status_temp       ; save off contents of STATUS register
		movf	PCLATH,w	      ; move pclath register into w register
		movwf	pclath_temp	  	  ; save off contents of PCLATH register
;-------------------------
			BTFSC	PIR1,TMR1IF	
			 GOTO	TMR1_INT	
			GOTO	ENDINT
;-------------------------
TMR1_INT	BANK0
			BCF		PIR1,TMR1IF
			MOVLW	LOBYTE				;  
			MOVWF	TMR1L
			MOVLW	HIBYTE
			MOVWF	TMR1H
;
			MOVLW	0xFF 
			XORWF	BITS,W
			XORLW	B'11111110'		;   
			MOVWF	BITS
;
			BTFSC	BEACONBIT		;   
			 CALL	BEACONWORK		;   
;
			BTFSC	BEEPBIT			; /  
			 CALL	BEEPER
;
			INCF	COUNTER1,F		;    CSQ
			INCF	COUNTER1A,F		;    CSQ
			INCF	COUNTER2,F		;   BEEP   CSQ
;
			INCF	TIME_MS20,F		;  20    .
			MOVLW	.20
			SUBWF	TIME_MS20,W
			BTFSS	STATUS,Z
 			 GOTO	ENDINT
;-------------------------  --------------------------------------------- 
			CLRF	TIME_MS20
;
			INCF	COUNTER3,F		;    PTT
			INCF	COUNTER4,F		;    PTT
			INCF	COUNTER5,F		;    PTT
;
			INCF	SEC,F	;  60    .
			MOVLW	.60
			SUBWF	SEC,W
			BTFSS	STATUS,Z
 			 GOTO	ENDINT
;-------------------------  --------------------------------------------- 
			CLRF	SEC
			INCF	COUNTER6,F		;     
;
			INCF	MIN,F			;  60   
			MOVLW	.60
			SUBWF	MIN,W
			BTFSS	STATUS,Z
 			 GOTO	ENDINT
;-------------------------  --------------------------------------------- 
			CLRF	MIN
			CALL	SINTEZ			;  
			INCF	HOUR,F
			MOVLW	.24
			SUBWF	HOUR,W
			BTFSS	STATUS,Z
 			 GOTO	ENDINT
;-------------------------  ---------------------------------------------
			CLRF	HOUR
;-------------------------
ENDINT	movf	pclath_temp,w	  ; retrieve copy of PCLATH register
		movwf	PCLATH		  	  ; restore pre-isr PCLATH register contents
		movf    status_temp,w     ; retrieve copy of STATUS register
		movwf	STATUS            ; restore pre-isr STATUS register contents
		swapf   w_temp,f
		swapf   w_temp,w          ; restore pre-isr W register contents
	retfie                  	  ; return from interrupt
;*********************************************************
START		CLRF	BITS
			CLRF	BITS1
			CLRF	TIME_MS20
			CLRF	SEC
			CLRF	MIN
			CLRF	HOUR
			CLRF	COUNTER6
			MOVLW	TIMEONAIR			;      
			MOVWF	VARONAIR			;   CSQ
;
			MOVLW	DTMFSTRING
			MOVWF	FSR
;
;---------------------------------------------------------
;   
			BANK1
			MOVLW	B'00001110'			; RA0/AN0 -  ,  - 
			MOVWF	ADCON1
			MOVLW	B'00111111'			;  6    .
			MOVWF	TRISA
			MOVLW	B'11111000'			;  B RB7-RB3 -  DTMF, RB2-RB0 - 
			MOVWF	TRISB
			MOVLW	0					;   - 
			MOVWF	TRISC
			BANK0
			BCF		PINCLOCK
;
			CLRF	PORTB
;
			MOVLW	B'00000111'			;  TMR2   16
			MOVWF	T2CON
;  TMR1 
			MOVLW	LOBYTE				;  50000  20 
			MOVWF	TMR1L	
			MOVLW	HIBYTE
			MOVWF	TMR1H
			BANK1
			BSF 	PIE1,TMR1IE			;   TMR1
			BANK0
			BSF		T1CON,TMR1ON		; TMR1 -  
			BSF		INTCON,PEIE			;   
			BSF		INTCON,GIE
;*********************************************************
			CALL	SINTEZ
CYCLE		CLRWDT
			BTFSS	PINCSQ
			 CALL	ONCSQ
			BTFSC	PINCSQ
			 CALL	OFFCSQ
;
			BTFSS	CSQBIT
			 CALL	OFFPTT
			BTFSC	CSQBIT
			 CALL	ONPTT
;
			BTFSC	CSQBIT
			 CALL	ONMODRX
			BTFSS	CSQBIT
			 CALL	OFFMODRX
;
			BTFSS	CSQBIT
			 CLRF	COUNTER4		;    CSQ
			BTFSC	ALARMBIT
			 CALL	ALARMWORK
;
			BTFSC	PINDTMF				;  ,    DTMF
			 BSF	PINDTMF_1
			BTFSC	PINDTMF_1			;   ,  
			 CALL	READDTMF	
			BTFSC	NEWDTMF
			 CALL	ENTERDTMF
			BTFSC	DTMF_OK
			 CALL	DTMFWORK
;
			CALL	BEACONTEST			;    
;
			GOTO	CYCLE
;*********************************************************
;---------------------------------------------------------
SOUND		MOVLW	B'00001100'
			MOVWF	CCP1CON				;  PWM
			 RETURN
;---------------------------------------------------------
NOSOUND		CLRF	CCP1CON
			BCF		PINPWM
			 RETURN
;---------------------------------------------------------
SETTONE		MOVF	TON,W
;			BCF		INTCON,GIE
			BANK1					;   
			MOVWF	PR2
			BANK0
;			BSF		INTCON,GIE
			BCF		STATUS,C
			RRF		TON,W
			MOVWF	CCPR1L			;   2
			 RETURN
;---------------------------------------------------------
ONCSQ		BTFSC	PTT
			 GOTO	SCNDSQ			;   
;
			BTFSC	CSQON1			;  
			 GOTO	TESTSQ1			;     
			BSF		CSQON1			;     
			CLRF	COUNTER1
			 RETURN
TESTSQ1		MOVF	COUNTER1,W
			SUBLW	TIMESQ1			;    ?
			BTFSC	STATUS,C
			 RETURN
			BCF		CSQON1			;     
			BSF		CSQBIT			;  CSQ
			CLRF	COUNTER3		;   
			 RETURN
;
SCNDSQ		BTFSC	CSQON1			; ,    
			 RETURN
;
			BTFSC	CSQOF			;    ?
			 GOTO	FASTCSQON		;    !!!
			BTFSC	CSQON2
			 GOTO	TESTSQ2
			BSF		CSQON2
			CLRF	COUNTER1
			 RETURN
TESTSQ2		MOVF	COUNTER1,W
			SUBLW	TIMESQ2			;    ?
			BTFSC	STATUS,C
			 RETURN
FASTCSQON	BCF		CSQON2			;     
			BSF		CSQBIT			;  CSQ
			BCF		CSQOF			;    CSQ			
			CLRF	COUNTER2		;    
			CLRF	COUNTER3		;   
			 RETURN
;---------------------------------------------------------
OFFCSQ		BTFSS	CSQBIT			;     SQ
			 RETURN
;
			BTFSC	CSQOF
			 GOTO	TESTOF1
			CLRF	COUNTER1A		;    CSQ
			BSF		CSQOF
			 RETURN
TESTOF1		MOVF	COUNTER1A,W		;   SQ 
			SUBLW	TIMEOFFSQ1
			BTFSC	STATUS,C
			 RETURN
			BCF		CSQOF
			BCF		CSQBIT
			CLRF	COUNTER2		;    
			 RETURN
;---------------------------------------------------------
ONPTT		BTFSC	ALARMBIT		;  PTT  
			 RETURN
			BTFSC	PTT
			 GOTO TIMEOUT1
			BSF		PTT
			CLRF	COUNTER4
			 RETURN
TIMEOUT1	MOVF	COUNTER4,W		;    
			SUBLW	TIMEOUT-2
			BTFSS	STATUS,Z
			 GOTO	TESTALARM
			MOVLW	HZ700
			MOVWF	TON
			CALL	SETTONE
			BSF		BEEPBIT
			 RETURN
;
TESTALARM	MOVF	COUNTER4,W		;  
			SUBLW	TIMEOUT
			BTFSS	STATUS,Z	
			 RETURN
			CLRF	COUNTER5
			BSF		ALARMBIT
			BCF		PTT
			 RETURN
;---------------------------------------------------------
OFFPTT		BTFSS	PTT
			 RETURN
;
			MOVF	COUNTER3,W		;     PTT
			SUBWF	VARONAIR,W
			BTFSC	STATUS,C
			 GOTO	TESTBEEP
;
			BTFSC	BEACONBIT		;   PTT,  
			 RETURN
			BCF		PTT
			 RETURN
;
TESTBEEP	MOVF	COUNTER2,W		;     
			SUBLW	TIME0FFBEEP		;   
			BTFSS	STATUS,Z			
			 RETURN
;
			BTFSC	BEACONBIT		;   ,  
			 RETURN
			BSF		BEEPBIT			;   BEEP
			 RETURN
;---------------------------------------------------------
BEEPER		BTFSS	TAKT			;   
			 GOTO	BEEPOFF
			MOVLW	HZ1000			;   1000 
			MOVWF	TON
			CALL	SETTONE
			GOTO	SOUND			;    
;
BEEPOFF		MOVF	CCP1CON,W
			ANDLW	B'00001100'
			SUBLW	B'00001100'
			BTFSS	STATUS,Z		;   ?
			 RETURN
			BCF		BEEPBIT
			GOTO	NOSOUND			;   
;---------------------------------------------------------
ONMODRX		CLRF	COUNTER5
			BTFSC	RXTOTX
			 RETURN
			BSF		RXTOTX
			 RETURN
;---------------------------------------------------------
OFFMODRX	BTFSC	OPENCSQ			;    ,  
			  RETURN
			BTFSS	RXTOTX
			 RETURN
			BCF		RXTOTX
			 RETURN
;---------------------------------------------------------
ALARMWORK	MOVF	COUNTER5,W		;      
			SUBLW	TIMEALARM
			BTFSS	STATUS,Z
			 RETURN
			BCF		ALARMBIT
			 RETURN
;---------------------------------------------------------
READDTMF	BTFSC	PINDTMF			;   0
			 RETURN
			BCF		PINDTMF_1
			MOVF	PORTB,W
			MOVWF	DTMFDATA
			RRF		DTMFDATA,F
			RRF		DTMFDATA,F
			RRF		DTMFDATA,W
			ANDLW	B'00001111'
			MOVWF	DTMFDATA
;
			BSF		NEWDTMF
			 RETURN
;---------   -------------------------
BEACONTEST	MOVF	COUNTER6,W
			SUBLW	TIMEBEACON
			BTFSS	STATUS,Z
			 RETURN
;
STARTBEACON	CLRF	PBIT				;    -    CHAR
			BSF		PBIT,7				; 7  -    
			CLRF	NUMCHAR				;  

			BSF		BEACONBIT			;   -  
			CLRF	COUNTER6			;    
			BSF		PTT					;  
;
			MOVLW	HZ1500				;   
			MOVWF	TON
			GOTO	SETTONE
;---------------------------------------------------------
;  DE EV1SR EV1SR QRA IS KO33TW KO33TW K 
; add offset to pc to generate a computed goto
TEXT	ADDWF    PCL,F
        DT      0x03,0xA8,0x40,0x08,0x55,0xC2,0xEE,0xEE,
        DT      0x15,0x0B,0xA0,0x04,0x2A,0xE1,0x77,0x77,
        DT      0x0A,0x85,0xD0,0x03,0xBA,0xE1,0x74,0x2E,
        DT      0x00,0x50,0xA8,0x01,0xD7,0x0E,0xEE,0x15,
        DT      0x77,0x0A,0xBB,0x87,0x0B,0xB8,0x01,0xD7,
        DT      0x0E,0xEE,0x15,0x77,0x0A,0xBB,0x87,0x0B,
        DT      0xB8,0x01,0xD7,0x00,0x00,0xFF
;---------------------------------------------------------
;  BY EW1LN EU1ABG EU1CC EW1RR EW2CU EW1PA MINSK 2004 K 
; add offset to pc to generate a computed goto
TEXT1	ADDWF    PCL
        DT      0x03,0xAA,0x1D,0x77,0x00,0x21,0x77,0x0B,
        DT      0xBB,0xB8,0x5D,0x43,0xA0,0x04,0x2B,0x85,
        DT      0xDD,0xDC,0x2E,0x1D,0x50,0xEE,0x80,0x10,
        DT      0xAE,0x17,0x77,0x70,0xEB,0xA1,0xD7,0x40,
        DT      0x08,0x5D,0xC2,0xEE,0xEE,0x17,0x42,0xE8,
        DT      0x01,0x0B,0xB8,0x57,0x77,0x0E,0xBA,0x15,
        DT      0xC0,0x08,0x5D,0xC2,0xEE,0xEE,0x17,0x74,
        DT      0x2E,0x00,0x77,0x0A,0x1D,0x0A,0x87,0x5C,
        DT      0x00,0xAE,0xEE,0x1D,0xDD,0xDC,0x3B,0xBB,
        DT      0xB8,0x55,0x70,0x03,0xAE,0x00,0x00,0xFF
;---------------------------------------------------------
;--   -------
TEXT_		MOVLW	HIGH TEXT	;  AN556E
			MOVWF	PCLATH
			MOVF	NUMCHAR,W	;      
			CALL	TEXT
			RETURN
;
TEXT1_		MOVLW	HIGH TEXT1	;  AN556E
			MOVWF	PCLATH
			MOVF	NUMCHAR,W	;      
			CALL	TEXT1
			RETURN
;------    -----------------------------
BEACONWORK	BTFSS	PBIT,7		;      ?
			 GOTO	SEND8		; , 
;
			BTFSS	INFO		;   
			 CALL	TEXT_
			BTFSC	INFO
			 CALL	TEXT1_
;
			MOVWF	CHAR		;       CHAR
			INCF	NUMCHAR,F	;  
			SUBLW	0xFF		;     
			BTFSC	STATUS,Z	; ,    
			 GOTO 	SNDEND
			BTFSC	CHAR,7		;  
			BSF		BBEEP		;   
			BTFSS	CHAR,7		;   
			 BCF	BBEEP		;   
			RLF		CHAR,F
			BCF		STATUS,C	; ,   
			RRF		PBIT,F
			GOTO	SETMORZE	; /  
;
SEND8:		BTFSC	CHAR,7		;  
	 		 BSF	BBEEP	;   
			BTFSS	CHAR,7		;   
			 BCF	BBEEP	;   
			RLF		CHAR,F
			BCF		STATUS,C	; ,   
			RRF		PBIT,F
			BTFSC	STATUS,C	;    (8)    ?
			 RRF	PBIT,F		; ,   -  7- -   
			GOTO	SETMORZE	; /  
;--------------------------------
SNDEND:		CLRF	NUMCHAR
			MOVF	COUNTER3,W		;     PTT
			SUBLW	TIMEONAIR
			BTFSC	STATUS,C
			 BCF		PTT
			BCF		BEACONBIT
			BCF		INFO			;  
			 RETURN
;---------------------------------------------------------
SETMORZE	BTFSS	BBEEP			;     
			 GOTO	NOSOUND
			GOTO	SOUND
;---------------------------------------------------------
;                 DTMF
;
; 0xxxxxxx#			  
;
; 10#				   
;
; 11#				 
;
; 121#				  -  PTT -   
; 120#				 -   
;
; 131#				   CSQ   10 
; 132#				   CSQ   30 
; 130#				 
;
; 73#				   
;
; 91PASSXXXX#		 
; 92PASS#			 
; 93PASS#			 
; 94PASSpasspass#	 
;---------------------------------------------------------
ENTERDTMF	MOVF	DTMFDATA,W		;    
			MOVWF	INDF
			INCF	FSR,F
			SUBLW	.12				; 12 - #   ?
			BTFSC	STATUS,Z
			 GOTO	ENDCOMM
			MOVF	DTMFDATA,W
			SUBLW	.11				; 11 - *   ?
			BTFSC	STATUS,Z
			 GOTO	DTMFCLEAR
			MOVLW	DTMFSTRING+.20	;    
			SUBWF	FSR,W
			BTFSS	STATUS,Z
			 GOTO	CHAROK
									;      -  
DTMFCLEAR	MOVLW	DTMFSTRING
			MOVWF	FSR
			GOTO	CHAROK
									;    
ENDCOMM		BSF		DTMF_OK
			MOVLW	DTMFSTRING		;  -   
			MOVWF	FSR
CHAROK		BCF		NEWDTMF			;     
			 RETURN
;------  -  ----------------------
DTMFWORK	BCF		DTMF_OK			;   - ,   
			MOVLW	1
			SUBWF	INDF,W			
			BTFSC	STATUS,Z
			 GOTO	COMMAND1		;   1
;
			MOVLW	7
			SUBWF	INDF,W			
			BTFSC	STATUS,Z
			 GOTO	COMMAND7		;   7
;
			MOVLW	9
			SUBWF	INDF,W
			BTFSC	STATUS,Z
			 GOTO	COMMAND9		;   9
			RETURN
;---------------   -------------------
COMMAND1	INCF	FSR
			MOVLW	.10				;    10,    
			SUBWF	INDF,W
			BTFSS	STATUS,Z
			 GOTO	COMMAND11
			BCF		OPENCSQ			;    
			MOVLW	TIMEONAIR		;     CSQ
			MOVWF	VARONAIR
			CLRF	COUNTER3
			RETURN			
;///////////////////////////////////
COMMAND11	MOVLW	1				;    1
			SUBWF	INDF,W
			BTFSS	STATUS,Z
			 GOTO	COMMAND12
			MOVLW	DTMFSTRING		;  -   
			MOVWF	FSR
			GOTO	STARTBEACON		;     11#
;///////////////////////////////////
COMMAND12	MOVLW	2				;    2
			SUBWF	INDF,W
			BTFSS	STATUS,Z
			 GOTO	COMMAND13
;
			INCF	FSR				;   
			MOVLW	1				;   1	
			SUBWF	INDF,W
			BTFSS	STATUS,Z
			 GOTO	COMMAND122
;
			BSF		OPENCSQ			;    
			MOVLW	DTMFSTRING		;  -   
			MOVWF	FSR
			RETURN

COMMAND122	MOVLW	.10				;   0
			SUBWF	INDF,W
			BTFSS	STATUS,Z
			 RETURN					;     
			BCF		OPENCSQ			;    
			MOVLW	DTMFSTRING		;  -   
			MOVWF	FSR
			RETURN
;///////////////////////////////////			
COMMAND13	MOVLW	3				;    3
			SUBWF	INDF,W
			BTFSS	STATUS,Z
			 GOTO	COMMAND14
			INCF	FSR				;   
;
			MOVLW	1				;   1	
			SUBWF	INDF,W
			BTFSS	STATUS,Z
			 GOTO	COMMAND132
			MOVLW	TIMEONAIR2		;     CSQ
			MOVWF	VARONAIR
			CLRF	COUNTER3
			RETURN
;
COMMAND132	MOVLW	2				;   2	
			SUBWF	INDF,W
			BTFSS	STATUS,Z
			 GOTO	COMMAND130
			MOVLW	TIMEONAIR3		;     CSQ
			MOVWF	VARONAIR
			CLRF	COUNTER3
			RETURN
;
COMMAND130	MOVLW	.10				;   0
			SUBWF	INDF,W
			BTFSS	STATUS,Z
			 RETURN					;     
			MOVLW	TIMEONAIR		;     CSQ
			MOVWF	VARONAIR
			CLRF	COUNTER3
			RETURN
;
COMMAND14	MOVLW	DTMFSTRING		;  -   
			MOVWF	FSR			
			RETURN				 
;----  7----------------------------------
COMMAND7	INCF	FSR
			MOVLW	.3				;    3,    
			SUBWF	INDF,W
			BTFSS	STATUS,Z
			 GOTO	COMMAND9
			BSF		INFO			;     
			GOTO	STARTBEACON		;   
;---------------------------------------------------------
COMMAND9	INCF	FSR
			MOVLW	DTMFSTRING
			MOVWF	FSR
			RETURN				 
;----  --------------------------------
RXDATA		ADDWF    PCL,F
			DT B'01000010', B'10100000', B'00100000'
TXDATA		ADDWF    PCL,F
			DT B'01000010', B'11011000', B'10100000'
;-----------------  RX  ------------------
SINTEZ		MOVLW	.8			;   
			MOVWF	COUNTBIT
			MOVLW	HIGH RXDATA	;  AN556E
			MOVWF	PCLATH
			MOVLW	0
			CALL	RXDATA
			MOVWF	DATABYTE
LOOP_0R		CALL	SENDBIT	
			DECFSZ	COUNTBIT,F
			 GOTO	LOOP_0R
;
			MOVLW	.8			;   
			MOVWF	COUNTBIT
			MOVLW	HIGH RXDATA	;  AN556E
			MOVWF	PCLATH
			MOVLW	1
			CALL	RXDATA
			MOVWF	DATABYTE
LOOP_1R		CALL	SENDBIT	
			DECFSZ	COUNTBIT,F
			 GOTO	LOOP_1R
;
			MOVLW	.3			;   
			MOVWF	COUNTBIT
			MOVLW	HIGH RXDATA	;  AN556E
			MOVWF	PCLATH
			MOVLW	2
			CALL	RXDATA
			MOVWF	DATABYTE
LOOP_2R		CALL	SENDBIT	
			DECFSZ	COUNTBIT,F
			 GOTO	LOOP_2R
			NOP
			NOP
			NOP
			BSF		PINRXEN		;  
			NOP
			NOP
			BCF		PINRXEN
;-----------------  TX  ------------------
			MOVLW	.8			;   
			MOVWF	COUNTBIT
			MOVLW	HIGH TXDATA	;  AN556E
			MOVWF	PCLATH
			MOVLW	0
			CALL	TXDATA
			MOVWF	DATABYTE
LOOP_0T		CALL	SENDBIT	
			DECFSZ	COUNTBIT,F
			 GOTO	LOOP_0T
;
			MOVLW	.8			;   
			MOVWF	COUNTBIT
			MOVLW	HIGH TXDATA	;  AN556E
			MOVWF	PCLATH
			MOVLW	1
			CALL	TXDATA
			MOVWF	DATABYTE
LOOP_1T		CALL	SENDBIT	
			DECFSZ	COUNTBIT,F
			 GOTO	LOOP_1T
;
			MOVLW	.3			;   
			MOVWF	COUNTBIT
			MOVLW	HIGH TXDATA	;  AN556E
			MOVWF	PCLATH
			MOVLW	2
			CALL	TXDATA
			MOVWF	DATABYTE
LOOP_2T		CALL	SENDBIT	
			DECFSZ	COUNTBIT,F
			 GOTO	LOOP_2T
			NOP
			NOP
			NOP
			BSF		PINTXEN		;  
			NOP
			NOP
			BCF		PINTXEN
			RETURN			
;---  ----------------------------------
SENDBIT		BSF		PINCLOCK
			NOP
			NOP
			RLF		DATABYTE,F
			BTFSS	STATUS,C
			 BCF	PINDATA
			BTFSC	STATUS,C
			 BSF	PINDATA
			NOP
			NOP
			NOP
			BCF		PINCLOCK
			RETURN
;---------------------------------------------------------
			END
